<id>
ViewProfile Intercept YaBB 2.6.11
</id>

<version>
0.2
</version>

<mod info>
This mod blocks guests from seeing member 'view profile' links. Admin can choose to have no link and a title 'pop-up' explaining that this is a member-only feature or a link to a 'Register or Login' screen.

Version History
---------------
0.1 - First release - Oct 8, 2014
0.2 - For 2.6.11 - Jan 15, 2015

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/Modlist.pm
cgi-bin/yabb2/Admin/NewSettings.pm
cgi-bin/yabb2/Admin/Settings_Main.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/BoardIndex.pm
cgi-bin/yabb2/Sources/Display.pm
cgi-bin/yabb2/Sources/EventCal.pm
cgi-bin/yabb2/Sources/EventCalBirthdays.pm
cgi-bin/yabb2/Sources/MessageIndex.pm
cgi-bin/yabb2/Sources/Poll.pm
cgi-bin/yabb2/Sources/Post.pm
cgi-bin/yabb2/Sources/Recent.pm
cgi-bin/yabb2/Sources/Search.pm
cgi-bin/yabb2/Sources/SubList.pm
cgi-bin/yabb2/Sources/Subs.pm
cgi-bin/yabb2/Templates/default/Other.template
</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $viewprofile_intercept = q~ViewProfile Intercept for 2.6.11|Dandello|Blocks guests from seeing member 'view profile' links. Admin can choose to have no link and a title 'pop-up' explaining that this is a member-only feature or a link to a 'Register or Login' screen.|0.2|01/15/15~;
    push @installed_mods, $viewprofile_intercept;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
1;
EOF
</search for>

<add before>
\$profile_int = $profile_int;               # 1 redirects guest clicks on member names to a register or login screen. 0 disables links on member names.
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
        {
            header => $settings_txt{'profile'},
</search for>

<add before>
        {
            description => qq~<label for="profile_int">$admin_txt{'profile_int'}</label>~,
            input_html => qq~<input type="checkbox" name="profile_int" id="profile_int" value="1"${ischecked($profile_int)} />~,
            name => 'profile_int',
        },
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$admin_txt{'profile_int'} = q~Redirect guest clicks on member name links to a 'Register or Login' page. Uncheck to disable member name links for guests.~;

</add before>

<edit file>
Languages/English/Main.lng
</edit file>

<search for>
1;
</search for>

<add before>
$maintxt{'members_only'} = q~Only members can access another member's profile.~;
$maintxt{'reg_please'} = qq~Please <a href="$scripturl?action=register" style="font-weight: bold;">register an account with us</a> or <a href="$scripturl?action=login" style="font-weight: bold;">login</a>.~;
$maintxt{'regplease'} = q~Please Register~;

</add before>

<edit file>
Sources/BoardIndex.pm
</edit file>

<search for>
                        if ( $iamguest ) {
                            $lastposter = qq~$format_unbold{$lastposter}~;
                        }
                        else {
                            $lastposter =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$lastposter}" rel="nofollow">$format_unbold{$lastposter}</a>~;
                        }
</search for>

<replace>
                        $lastposter = profile_view($lastposter);
</replace>

<edit file>
Sources/Display.pm
</edit file>

<search for>
                if ( $iamguest ) {
                    $mlmb = qq~$format_unbold{$mlmb}~;
                }
                else {
                    $mlmb =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$mlmb}">$format_unbold{$mlmb}</a>~;
                }
</search for>

<replace>
                $mlmb = profile_view($mlmb);
</replace>

<edit file>
Sources/EventCal.pm
</edit file>

<search for>
                        if ( $iamguest ) {
                            $eventuserlink = qq~$format_unbold{$cnam}~;
                        }
                        else {
                            $eventuserlink =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$cnam}" rel="nofollow">$format_unbold{$cnam}</a>~;
                        }
</search for>

<replace>
                        $eventuserlink = profile_view($cnam);
</replace>

<search for>
                        if ( $iamguest ) {
                            $eventuserlink = qq~$format_unbold{$cnam}~;
                        }
                        else {
                            $eventuserlink =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$cnam}" rel="nofollow">$format_unbold{$cnam}</a>~;
                        }
</search for>

<replace>
                        $eventuserlink = profile_view($cnam);
</replace>

<search for>
                if ( $iamguest ) {
                    $eventuserlink = qq~$format_unbold{$cnam}~;
                }
                else {
                    $eventuserlink =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$cname}" rel="nofollow">$format_unbold{$cname}</a>~;
                }
</search for>

<replace>
                $eventuserlink = profile_view($cname);
</replace>

<edit file>
Sources/EventCalBirthdays.pm
</edit file>

<search for>
                    if ( $iamguest ) {
                        $user_linkprofile = qq~$format_unbold{$user_bdname}~;
                    }
                    else {
                        $user_linkprofile =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user_bdname}" rel="nofollow">$format_unbold{$user_bdname}</a>~;
                    }
</search for>

<replace>
                    $user_linkprofile = profile_view($user_bdname);
</replace>

<search for>
                        if ( $iamguest ) {
                            $user_linkprofile = qq~$format_unbold{$user_bdname}~;
                        }
                        else {
                            $user_linkprofile =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user_bdname}" rel="nofollow">$format_unbold{$user_bdname}</a>~;
                        }
</search for>

<replace>
                        $user_linkprofile = profile_view($user_bdname);
</replace>

<search for>
                                if ( $iamguest ) {
                                    $user_linkprofile = qq~$format_unbold{$user_bdname}~;
                                }
                                else {
                                    $user_linkprofile = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user_bdname}" rel="nofollow">$format_unbold{$user_bdname}</a>~;
                                }
</search for>

<replace>
                                $user_linkprofile = profile_view($user_bdname);
</replace>

<edit file>
Sources/MessageIndex.pm
</edit file>

<search for>
                if ( $iamguest) {
                    $mname = $format_unbold{$musername};
                }
                else {
                    $mname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$format_unbold{$musername}</a>~;
                }
</search for>

<replace>
                $mname = profile_view($musername);
</replace>

<search for>
                if ( $iamguest) {
                    $lastposter = $format_unbold{$lastposter};
                }
                else {
                    $lastposter =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$lastposter}">$format_unbold{$lastposter}</a>~;
                }
</search for>

<replace>
                $lastposter = profile_view($lastposter);
</replace>

<edit file>
Sources/Poll.pm
</edit file>

<search for>
    if ( $poll_modname ne q{} && $poll_mod ne q{} ) {
</search for>

<add before>
    $linkprofile = q{};
</add before>

<search for>
        if ( $iamguest ) {
            $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: $format_unbold{$poll_modname} $polltxt{'46'}: $poll_mod &#187;</span>~;
        }
        else {
            $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$poll_modname}">$format_unbold{$poll_modname}</a> $polltxt{'46'}: $poll_mod &#187;</span>~;
        }
</search for>

<replace>
        $linkprofile = profile_view($poll_modname);
        $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: $linkprofile $polltxt{'46'}: $poll_mod &#187;</span>~;
</replace>

<search for>
            if ( $iamguest ) {
                $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: $format_unbold{$poll_uname} $polltxt{'46'}: $poll_mod &#187;</span>~;
            }
            else {
                $displaydate =
qq~<span class="small">&#171; $polltxt{'45'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$poll_uname}">$format_unbold{$poll_uname}</a> $polltxt{'46'}: $poll_date &#187;</span>~;
            }
</search for>

<replace>
            $linkprofile = profile_view($poll_uname);
            $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: $linkprofile $polltxt{'46'}: $poll_mod &#187;</span>~;
</replace>

<search for>
            if ( $iamguest ) {
                $voters_name = qq~$format_unbold{$voters_name}~;
            }
            else {
                $voters_name =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$voters_name}">$format_unbold{$voters_name}</a>~;
            }
</search for>

<replace>
            $voters_name = profile_view($voters_name);
</replace>

<search for>
        if ( $iamguest ) {
            $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: $format_unbold{$poll_modname} $polltxt{'46'}: $poll_mod &#187;</span>~;
        }
        else {
            $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$poll_modname}">$format_unbold{$poll_modname}</a> $polltxt{'46'}: $poll_mod &#187;</span>~;
        }
</search for>

<replace>
        $linkprofile = profile_view($poll_modname);
        $displaydate =
qq~<span class="small">&#171; $polltxt{'45a'}: $linkprofile $polltxt{'46'}: $poll_mod &#187;</span>~;
</replace>

<search for>
            if ( $iamguest ) {
                $displaydate =
qq~<span class="small">&#171; $polltxt{'45'}: $format_unbold{$poll_uname} $polltxt{'46'}: $poll_date &#187;</span>~;
            }
            else {
                $displaydate =
qq~<span class="small">&#171; $polltxt{'45'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$poll_uname}">$format_unbold{$poll_uname}</a> $polltxt{'46'}: $poll_date &#187;</span>~;
            }
</search for>

<replace>
            $linkprofile = profile_view($poll_uname);
            $displaydate =
qq~<span class="small">&#171; $polltxt{'45'}: $linkprofile $polltxt{'46'}: $poll_date &#187;</span>~;
</replace>

<edit file>
Sources/Post.pm
</edit file>

<search for>
                if ( $iamguest) {
                    $displaynamelink = qq~$format_unbold{$tempname}~;
                }
                else {
                    $displaynamelink =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tempname}">$format_unbold{$tempname}</a>~;
                }
</search for>

<replace>
                $displaynamelink = profile_view($tempname);
</replace>

<edit file>
Sources/Recent.pm
</edit file>

<search for>
            if ( $iamguest ) {
                $tname = qq~$format_unbold{$tusername}~;
            }
            else {
                $tname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tusername}" rel="nofollow">$format_unbold{$tusername}</a>~;
            }
</search for>

<replace>
            $tname = profile_view($tusername);
</replace>

<search for>
            if ( $iamguest ) {
                $mname = qq~$format_unbold{$musername}~;
            }
            else {
                $mname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" rel="nofollow">$format_unbold{$musername}</a>~;
            }
</search for>

<replace>
            $mname = profile_view($musername);
</replace>

<search for>
            if ( $iamguest ) {
                $tname = qq~$format_unbold{$tusername}~;
            }
            else {
                $tname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tusername}" rel="nofollow">$format_unbold{$tusername}</a>~;
            }
</search for>

<replace>
            $tname = profile_view($tusername);
</replace>

<search for>
            if ( $iamguest ) {
                $mname = qq~$format_unbold{$tusername}~;
            }
            else {
                $mname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" rel="nofollow">$format_unbold{$musername}</a>~;
            }
</search for>

<replace>
            $mname = profile_view($musername);
</replace>

<edit file>
Sources/Search.pm
</edit file>

<search for>
        if ( $iamguest) {
            $mname = $format_unbold{$user};
        }
        else {
            $mname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user}">$format_unbold{$user}</a>~;
        }
</search for>

<replace>
        $mname = profile_view($user);
</replace>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
$director{'link_profileview'} = 'Subs.pm&link_profileview';

</add before>

<edit file>
Sources/Subs.pm
</edit file>

<search for>
1;
</search for>

<add before>
sub profile_view {
    my($puser) = @_;
    if ( $iamguest ) {
        $pname = qq~<span title="$maintxt{'members_only'}">$format_unbold{$puser}</span>~;
        if ( $profile_int ) {
            $pname = qq~<a href="$scripturl?action=link_profileview">$format_unbold{$puser}</a>~;
        }
    }
    else {
        $pname =
qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$puser}" rel="nofollow">$format_unbold{$puser}</a>~;
    }

    return $pname;
}

sub link_profileview {
    get_template('Other');
    $yymain .= $my_profile_int;
    $yytitle      = qq~$maintxt{'regplease'}~;
    $yynavigation = qq~&rsaquo; $maintxt{'regplease'}~;
    template();

    return;
}

</add before>

<edit file>
Templates/default/Other.template
</edit file>

<search for>
1;
</search for>

<add before>
## Guest Profile link interrupt

$my_profile_int = qq~
<table class="system-info" style="width:50em">
    <tr>
        <td>$maintxt{'members_only'}</td>
    </tr>
</table>
<table class="system-info-body" style="width:50em">
    <tr>
        <td class="center">$maintxt{'reg_please'}</td>
    </tr>
</table>
<br /><div style="width: 100%; text-align: center;"><a href="javascript:history.go(-1)">$maintxt{'193'}</a></div>
~;

</add before>